<?php

/* #############################################################################
  Project Name: NextScripts Pinterest AutoPoster
  Project URL: http://www.nextscripts.com/pinterest-automated-posting/
  Description: Automatically posts to your Pinterest profile
  Author: NextScripts, Inc
  Version: 2.15.9 (May, 20 2014)
  Author URL: http://www.nextscripts.com
  Copyright 2012-2014  Next Scripts, Inc
 * *** Please Note: This library is depreciated and will be no longer supported or updated after May, 20 2015. 
 * *** Please update to the Universal SNAP API - http://www.nextscripts.com/snap-api/
  ############################################################################# */
require_once "nxs-http.php";
require_once 'simple_html_dom.php';

global $nxs_gCookiesArr;

if (!function_exists('prr')) {

	function prr($str) {
		echo "<pre>";
		print_r($str);
		echo "</pre>\r\n";
	}

}
//## Code - General Functions
if (!function_exists("CutFromTo")) {

	function CutFromTo($string, $from, $to) {
		$fstart = stripos($string, $from);
		$tmp = substr($string, $fstart + strlen($from));
		$flen = stripos($tmp, $to);
		return substr($tmp, 0, $flen);
	}

}
if (!function_exists("getUqID")) {

	function getUqID() {
		return mt_rand(0, 9999999);
	}

}
if (!function_exists("build_http_query")) {

	function build_http_query($query) {
		$query_array = array();
		foreach ($query as $key => $key_value) {
			$query_array[] = $key . '=' . urlencode($key_value);
		} return implode('&', $query_array);
	}

}
if (!function_exists("rndString")) {

	function rndString($lngth) {
		$str = '';
		$chars = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
		$size = strlen($chars);
		for ($i = 0; $i < $lngth; $i++) {
			$str .= $chars[rand(0, $size - 1)];
		} return $str;
	}

}
if (!function_exists("prcGSON")) {

	function prcGSON($gson) {
		$json = substr($gson, 5);
		$json = str_replace(',{', ',{"', $json);
		$json = str_replace(':[', '":[', $json);
		$json = str_replace(',{""', ',{"', $json);
		$json = str_replace('"":[', '":[', $json);
		$json = str_replace('[,', '["",', $json);
		$json = str_replace(',,', ',"",', $json);
		$json = str_replace(',,', ',"",', $json);
		return $json;
	}

}
if (!function_exists("nxsCheckSSLCurl")) {

	function nxsCheckSSLCurl($url) {
		$ch = curl_init($url);
		$headers = array();
		$headers[] = 'Accept: text/html, application/xhtml+xml, */*';
		$headers[] = 'Cache-Control: no-cache';
		$headers[] = 'Connection: Keep-Alive';
		$headers[] = 'Accept-Language: en-us';
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)");
		$content = curl_exec($ch);
		$err = curl_errno($ch);
		$errmsg = curl_error($ch);
		if ($err != 0)
			return array('errNo' => $err, 'errMsg' => $errmsg); else
			return false;
	}

}
if (!function_exists("nxs_clFN")) {

	function nxs_clFN($fn) {
		$sch = array("?", "[", "]", "/", "\\", "=", "<", ">", ":", ";", ",", "'", "\"", "&", "$", "#", "*", "(", ")", "|", "~", "`", "!", "{", "}");
		return trim(preg_replace('/[\s-]+/', '-', str_replace($sch, '', $fn)), '.-_');
	}

}
if (!function_exists("nxs_mkImgNm")) {

	function nxs_mkImgNm($fn, $cType) {
		$iex = array(".png", ".jpg", ".gif", ".jpeg");
		$map = array('image/gif' => '.gif', 'image/jpeg' => '.jpg', 'image/png' => '.png');
		$fn = str_replace($iex, '', $fn);
		if (isset($map[$cType])) {
			return $fn . $map[$cType];
		} else
			return $fn . ".jpg";
	}

}

//================================Pinterest===========================================
//## Check current  Pinterest session
if (!function_exists("doConnectToPinterest")) {

	function doConnectToPinterest($email, $pass, $iidb = 0) {
		global $nxs_plurl, $nxs_gCookiesArr, $plgn_NS_SNAutoPoster;
		if (isset($plgn_NS_SNAutoPoster)) {
			$options = $plgn_NS_SNAutoPoster->nxs_options;
			if (isset($options['li'][$iidb]['ck']))
				$ck = maybe_unserialize($options['li'][$iidb]['ck']);
		} else
			$ck = array();
		
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($ck)) $nt->ck = $ck; 
		
		$loginErr = $nt->connect($email, $pass);
		$nxs_gCookiesArr = $nt->ck;
		if (isset($plgn_NS_SNAutoPoster) && !empty($options)) {
			if (!$loginErr) {
				$options['li'][$iidb]['ck'] = $nt->ck;
				if (is_array($options)) {
					update_option('NS_SNAutoPoster', $options);
					$plgn_NS_SNAutoPoster->nxs_options = $options;
				}
			}
		} return $loginErr;
	}

}
if (!function_exists("doCheckPinterest")) {

	function doCheckPinterest() {
		global $nxs_gCookiesArr;
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr;
		return !$nt->check();
	}

}
if (!function_exists("doGetBoardsFromPinterest")) {

	function doGetBoardsFromPinterest() {
		global $nxs_gCookiesArr;
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr;
		
		$boards = $nt->getBoards();
		return $boards;
	}

}

if (!function_exists("doGetPinterestUserName")) {

	function doGetPinterestUserName() {
		global $nxs_gCookiesArr;
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr;
		
		$name = $nt->getUserName();
		return $name;
	}

}

if (!function_exists("doGetPinterestUserIcon")) {

	function doGetPinterestUserIcon() {
		global $nxs_gCookiesArr;
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr;
		
		$name = $nt->getUserIcon();
		return $name;
	}
}

if (!function_exists("doPostToPinterest")) {

	function doPostToPinterest($msg, $imgURL, $lnk, $boardID, $title = '', $price = '', $via = '') {
		global $nxs_gCookiesArr;
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr; $ret = $nt->post($msg, $imgURL, $lnk, $boardID, $title, $price, $via); // prr($ret);
		if (is_array($ret) && !empty($ret['isPosted']))
			return array("code" => "OK", "post_id" => $ret['postID'], "post_url" => $ret['postURL']); else
			return $ret;
	}

}
if (!function_exists("doCreateBoard")) {

	function doCreateBoard($board_name, $board_description = '') {
		
		global $nxs_gCookiesArr, $nxs_pUserName;
		
		$nt = new nxsAPI_PN();
		$nt->debug = false;
		if (!empty($nxs_gCookiesArr))
			$nt->ck = $nxs_gCookiesArr;
		$ret = $nt->createBoard($board_name, $board_description); // prr($ret);
		if (is_array($ret) && !empty($ret['isPosted']))
			return array("code" => "OK", "post_id" => $ret['postID'], "post_url" => $ret['postURL']); else
		return $ret;
	}

}
if (!class_exists('nxsAPI_PN')) {

	class nxsAPI_PN {

		var $ck = array();
		var $tk = '';
		var $boards = '';
		var $apVer = '';
		var $debug = false;
		var $ssl_off = true;
		var $userName = '';
		var $userIcon = '';

		function headers($ref, $org = '', $type = 'GET', $aj = false) {
			$hdrsArr = array();
			$hdrsArr['Cache-Control'] = 'max-age=0';
			$hdrsArr['Connection'] = 'keep-alive';
			$hdrsArr['Referer'] = $ref;
			$hdrsArr['User-Agent'] = 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.22 Safari/537.36';
			if ($type == 'JSON')
				$hdrsArr['Content-Type'] = 'application/json;charset=UTF-8'; elseif ($type == 'POST')
				$hdrsArr['Content-Type'] = 'application/x-www-form-urlencoded';
			if ($aj === true)
				$hdrsArr['X-Requested-With'] = 'XMLHttpRequest'; if ($org != '')
				$hdrsArr['Origin'] = $org;
			if ($type == 'GET')
				$hdrsArr['Accept'] = 'text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'; else
				$hdrsArr['Accept'] = '*/*';
			if (function_exists('gzdeflate'))
				$hdrsArr['Accept-Encoding'] = 'gzip,deflate,sdch';
			$hdrsArr['Accept-Language'] = 'en-US,en;q=0.8';
			return $hdrsArr;
		}

		function check() {
			$ck = $this->ck;
			if (!empty($ck) && is_array($ck)) {
				$hdrsArr = $this->headers('https://www.pinterest.com/settings/');
				if ($this->debug)
					echo "[PN] Checking....;<br/>\r\n";
				
				$rep = nxs_remote_get('https://www.pinterest.com/settings/', array('headers' => $hdrsArr, 'httpversion' => '1.1', 'cookies' => $ck, 'ssl_off' => $this->ssl_off));
				
				if (is_nxs_error($rep))
					return false;
				
				$ck = $rep['cookies'];
				$contents = $rep['body']; //if ($this->debug) prr($contents);
				
				$html = str_get_html($contents);
				foreach ($html->find('#userUserName') as $element) {
					$this->userName = str_replace('/', '', $element->getAttribute('value'));
				};
				
				foreach ($html->find('.profileImageWrapper img') as $element) {
					$this->userIcon = $element->src;
				};

				return stripos($contents, 'href="#accountBasics"') !== false;
			} else
				return false;
		}

		function connect($u, $p) {
			$badOut = 'Error: ';
			//## Check if alrady IN
			if (!$this->check()) {
				if ($this->debug)
					echo "[PN] NO Saved Data;<br/>\r\n";
				$hdrsArr = $this->headers('https://www.pinterest.com/login/');
				//$rep = nxs_remote_get('https://www.pinterest.com/login/', array('headers' => $hdrsArr, 'httpversion' => '1.1'));
				$rep = nxs_remote_get('https://www.pinterest.com/login/', array('headers' => $hdrsArr, 'httpversion' => '1.1', 'ssl_off' => $this->ssl_off ));
				if (is_nxs_error($rep)) {
					$badOut = print_r($rep, true) . " - ERROR";
					return $badOut;
				} 
				$ck = $rep['cookies'];
				foreach ($ck as $ci => $cc)
					$ck[$ci]->value = str_replace(' ', '+', $cc->value); 
				$contents = $rep['body'];
				$apVer = trim(CutFromTo($contents, '"app_version": "', '"'));
				//$fldsTxt = 'data=%7B%22options%22%3A%7B%22username_or_email%22%3A%22' . urlencode($u) . '%22%2C%22password%22%3A%22' . urlencode($p) . '%22%7D%2C%22context%22%3A%7B%22app_version%22%3A%22' . $apVer . '%22%7D%7D&source_url=%2Flogin%2F&module_path=App()%3ELoginPage()%3ELogin()%3EButton(class_name%3Dprimary%2C+text%3DLog+in%2C+type%3Dsubmit%2C+tagName%3Dbutton%2C+size%3Dlarge)';
				$fldsTxt = 'source_url=%2Flogin%2F&data=%7B%22options%22%3A%7B%22username_or_email%22%3A%22' . urlencode($u) . '%22%2C%22password%22%3A%22' . urlencode($p) . '%22%7D%2C%22context%22%3A%7B%7D%7D&module_path=App()%3ELoginPage()%3ELogin()%3EButton(class_name%3Dprimary%2C+text%3D%D0%92%D1%85%D0%BE%D0%B4%2C+type%3Dsubmit%2C+size%3Dlarge)';
				
				foreach ($ck as $c)
					if ($c->name == 'csrftoken')
						$xftkn = $c->value;
				//## ACTUAL LOGIN 
				$hdrsArr = $this->headers('https://www.pinterest.com/login/', 'https://www.pinterest.com', 'POST', true);
				$hdrsArr['X-NEW-APP'] = '1';
				$hdrsArr['X-APP-VERSION'] = $apVer;
				$hdrsArr['X-CSRFToken'] = $xftkn;
				$advSet = array('headers' => $hdrsArr, 'httpversion' => '1.1', 'timeout' => 45, 'redirection' => 0, 'cookies' => $ck, 'body' => $fldsTxt, 'ssl_off' =>$this->ssl_off); // prr($advSet);
				$rep = nxs_remote_post('https://www.pinterest.com/resource/UserSessionResource/create/', $advSet);
				//var_dump($rep); exit;
				if (is_nxs_error($rep)) {
					$badOut = print_r($rep, true) . " - ERROR";
					return $badOut;
				}
				if (!empty($rep['body'])) {
					$contents = $rep['body'];
					$resp = json_decode($contents, true);
				} else {
					$badOut = print_r($rep, true) . " - ERROR";
					return $badOut;
				}
				if (empty($resp['resource_response']['error'])) {
					$ck = $rep['cookies'];
					foreach ($ck as $ci => $cc)
						$ck[$ci]->value = str_replace(' ', '+', $cc->value);
					$hdrsArr = $this->headers('https://www.pinterest.com/login');
					$rep = nxs_remote_get('https://www.pinterest.com/', array('headers' => $hdrsArr, 'redirection' => 0, 'cookies' => $ck, 'httpversion' => '1.1', 'ssl_off' => $this->ssl_off));
					
					if(is_array($rep['cookies']) && is_array($ck)){
						$ck = array_merge($rep['cookies'], $ck);
					}else{
						$ck = $rep['cookies'];
					};
						
					foreach ($ck as $ci => $cc)
						$ck[$ci]->value = str_replace(' ', '+', $cc->value); 
					$this->tk = $xftkn;
					$this->ck = $ck;
					$this->apVer = $apVer;
					if ($this->debug)
						echo "[PN] You are IN;<br/>\r\n"; // echo "You are IN";                                       
				} elseif (is_array($resp) && isset($resp['resource_response']['error']))
					return "ERROR: " . $resp['resource_response']['error']['http_status'] . " | " . $resp['resource_response']['error']['message'];
				elseif (stripos($contents, 'CSRF verification failed') !== false) {
					$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
					return "CSRF verification failed - Please contact NextScripts Support | Pinterest Message:" . $retText;
				} elseif (stripos($contents, 'IP because of suspicious activity') !== false)
					return 'Pinterest blocked logins from this IP because of suspicious activity';
				elseif (stripos($contents, 've detected a bot!') !== false)
					return 'Pinterest has your IP (' . CutFromTo($contents, 'ess: <b>', '<') . ') blocked. Please <a target="_blank" class="link" href="//help.pinterest.com/entries/22914692">Contact Pinterest</a> and ask them to unblock your IP. ';
				elseif (stripos($contents, 'bot running on your network') !== false)
					return 'Pinterest has your IP (' . CutFromTo($contents, 'Your IP is:', '<') . ') blocked. Please <a target="_blank" class="link" href="//help.pinterest.com/entries/22914692">Contact Pinterest</a> and ask them to unblock your IP. ';
				else
					return 'Pinterest login failed. Unknown Error. Please contact support.';
			} else {
				if ($this->debug)
					echo "[PN] Saved Data is OK;<br/>\r\n"; return false;
			}
		}

		function getUserName(){
			if (!$this->check()) {
				if ($this->debug) echo "[PN] NO Saved Data;<br/>\r\n";
				return 'Not logged IN';
			};
			return $this->userName;
		}

		function getUserIcon(){
			if (!$this->check()) {
				if ($this->debug) echo "[PN] NO Saved Data;<br/>\r\n";
				return 'Not logged IN';
			};
			return $this->userIcon;
		}		
		
		function getBoards() {
			if (!$this->check()) {
				if ($this->debug) echo "[PN] NO Saved Data;<br/>\r\n";
				return 'Not logged IN';
			};
			$boards = '';
			$ck = $this->ck;
			$apVer = $this->apVer;
			$brdsArr = array();
			$iu = 'http://memory.loc.gov/award/ndfa/ndfahult/c200/c240r.jpg';
			$su = '/pin/find/?url=' . urlencode($iu);
			$hdrsArr = $this->headers('http://www.pinterest.com/pin/find/?url=' . urlencode($iu), '', 'JSON', true);
			$hdrsArr['X-NEW-APP'] = '1';
			$hdrsArr['X-APP-VERSION'] = $apVer;
			$hdrsArr['Accept'] = 'application/json, text/javascript, */*; q=0.01';
			$dt = '{"options":{},"context":{},"module":{"name":"PinCreate","options":{"image_url":"' . $iu . '","action":"create","method":"scraped","link":"' . $iu . '","transparent_modal":false}},"append":false,"error_strategy":0}';
			$advSet = array('headers' => $hdrsArr, 'httpversion' => '1.1', 'timeout' => 45, 'redirection' => 0, 'cookies' => $ck, 'ssl_off' =>$this->ssl_off);
			$rep = nxs_remote_get('http://www.pinterest.com/resource/NoopResource/get/?source_url=' . urlencode($su) . '&data=' . urlencode($dt), $advSet);
			if (is_nxs_error($rep)) {
				$badOut = print_r($rep, true) . " - ERROR";
				return $badOut;
			} $ck = $rep['cookies'];
			$contents = $rep['body'];
			$k = json_decode($contents, true);
			$khtml = CutFromTo($k['module']['html'], "boardPickerInnerWrapper", "</ul>");
			$khA = explode('<li', $khtml);
			foreach ($khA as $kh)
				if (stripos($kh, 'data-id') !== false) {
					$bid = CutFromTo($kh, 'data-id="', '"');
					$bname = trim(CutFromTo($kh, '</div>', '</li>'));
					if (isset($bid)) {
						$boards .= '<option value="' . $bid . '">' . trim($bname) . '</option>';
						$brdsArr[] = array('id' => $bid, 'n' => trim($bname));
					}
				} $this->boards = $brdsArr;
			return $brdsArr;
		}

		function post($msg, $imgURL, $lnk, $boardID, $title = '', $price = '', $via = '') {
			$tk = $this->tk;
			$ck = $this->ck;
			$apVer = $this->apVer;
			if (empty($tk))
				foreach ($ck as $c)
					if ($c->name == 'csrftoken')
						$tk = $c->value; $msg = strip_tags($msg);
			$msg = substr($msg, 0, 480);
			$tgs = '';
			$this->tk = $tk;
			if ($msg == '')
				$msg = '&nbsp;'; if (trim($boardID) == '')
				return "Board is not Set"; if (trim($imgURL) == '')
				return "Image is not Set"; $msg = str_ireplace(array("\r\n", "\n", "\r"), " ", $msg);
			$msg = strip_tags($msg);
			if (function_exists('nxs_decodeEntitiesFull'))
				$msg = nxs_decodeEntitiesFull($msg, ENT_QUOTES);
			$mgsOut = urlencode($msg);
			$mgsOut = str_ireplace(array('%28', '%29', '%27', '%21', '%22', '%09'), array("(", ")", "'", "!", "%5C%22", '%5Ct'), $mgsOut);
			$fldsTxt = 'source_url=%2Fpin%2Ffind%2F%3Furl%3D' . urlencode(urlencode($lnk)) . '&data=%7B%22options%22%3A%7B%22board_id%22%3A%22' . $boardID . '%22%2C%22description%22%3A%22' . $mgsOut . '%22%2C%22link%22%3A%22' . urlencode($lnk) . '%22%2C%22share_facebook%22%3Afalse%2C%22image_url%22%3A%22' . urlencode($imgURL) . '%22%2C%22method%22%3A%22scraped%22%7D%2C%22context%22%3A%7B%22app_version%22%3A%2250c6169%22%7D%7D';

			$hdrsArr = $this->headers('http://www.pinterest.com/resource/PinResource/create/', 'http://www.pinterest.com', 'POST', true);
			$hdrsArr['X-NEW-APP'] = '1';
			$hdrsArr['X-APP-VERSION'] = $apVer;
			$hdrsArr['X-CSRFToken'] = $tk;
			$advSet = array('headers' => $hdrsArr, 'httpversion' => '1.1', 'timeout' => 45, 'redirection' => 0, 'cookies' => $ck, 'body' => $fldsTxt, 'ssl_off' =>$this->ssl_off);
			$rep = nxs_remote_post('http://www.pinterest.com/resource/PinResource/create/', $advSet);
			if (is_nxs_error($rep)) {
				$badOut = print_r($rep, true) . " - ERROR";
				return $badOut;
			}
			$contents = $rep['body'];
			$resp = json_decode($contents, true); //  prr($advSettings);  prr($resp);   prr($fldsTxt);  prr($contents);    
			if (is_array($resp)) {
				if (isset($resp['resource_response']) && isset($resp['resource_response']['error']) && $resp['resource_response']['error'] != '')
					return print_r($resp['resource_response']['error'], true);
				elseif (isset($resp['resource_response']) && isset($resp['resource_response']['data']) && $resp['resource_response']['data']['id'] != '') { // gor JSON
					if (isset($resp['resource_response']) && isset($resp['resource_response']['error']) && $resp['resource_response']['error'] != '')
						return print_r($resp['resource_response']['error'], true);
					else
						return array("code" => "OK", "post_id" => $resp['resource_response']['data']['id'], "post_url" => "http://www.pinterest.com/resource/pin/" . $resp['resource_response']['data']['id']);
				}
			}elseif (stripos($contents, 'blocked this') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "Pinterest ERROR: 'The Source is blocked'. Please see https://support.pinterest.com/entries/21436306-why-is-my-pin-or-site-blocked-for-spam-or-inappropriate-content/ for more info | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'image you tried to pin is too small') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "Image you tried to pin is too small | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'CSRF verification failed') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "CSRF verification failed - Please contact NextScripts Support | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'Oops') !== false && stripos($contents, '<body>') !== false)
				return 'Pinterest ERROR MESSAGE : ' . trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
			else
				return "Somethig is Wrong - Pinterest Returned Error 502";
		}
		
		function createBoard($board_name, $board_description) {
			if (!$this->check()) {
				if ($this->debug) echo "[PN] NO Saved Data;<br/>\r\n";
				return 'Not logged IN';
			};
			
			$tk = $this->tk;
			$ck = $this->ck;
			$apVer = $this->apVer;
			if (empty($tk))
				foreach ($ck as $c)
					if ($c->name == 'csrftoken')
						$tk = $c->value;
					
			$tgs = '';
			$this->tk = $tk;
			
			$board_description = strip_tags($board_description);
			$board_description = substr($board_description, 0, 480);
			if ($board_description == '') 
				$board_description = '&nbsp;';
			$board_description = str_ireplace(array("\r\n", "\n", "\r"), " ", $board_description);
			$board_description = strip_tags($board_description);
			if (function_exists('nxs_decodeEntitiesFull'))
				$board_description = nxs_decodeEntitiesFull($board_description, ENT_QUOTES);
			$mgsOut = urlencode($board_description);
			
			$mgsOut = str_ireplace(array('%28', '%29', '%27', '%21', '%22', '%09'), array("(", ")", "'", "!", "%5C%22", '%5Ct'), $mgsOut);
			//$fldsTxt = 'source_url=%2Fpin%2Ffind%2F%3Furl%3D' . urlencode(urlencode($lnk)) . '&data=%7B%22options%22%3A%7B%22board_id%22%3A%22' . $boardID . '%22%2C%22description%22%3A%22' . $mgsOut . '%22%2C%22link%22%3A%22' . urlencode($lnk) . '%22%2C%22share_facebook%22%3Afalse%2C%22image_url%22%3A%22' . urlencode($imgURL) . '%22%2C%22method%22%3A%22scraped%22%7D%2C%22context%22%3A%7B%22app_version%22%3A%2250c6169%22%7D%7D';

			$board_name = urlencode(strip_tags($board_name));
			
			$fldsTxt = 'source_url=%2F'.$this->userName.'%2F&'.
						'data=%7B%22options%22%3A%7B%22name%22%3A%22'.$board_name.'%22%2C%22category%22%3A%22other%22%2C%22description%22%3A%22'.$mgsOut.'%22%2C%22privacy%22%3A%22public%22%2C%22layout%22%3A%22default%22%7D%2C%22context%22%3A%7B%7D%7D&'.
						'module_path=App()%3EUserProfilePage(resource%3DUserResource(username%3D'.$this->userName.'))%3EUserProfileContent(resource%3DUserResource(username%3D'.$this->userName.'))%3EUserBoards()%3EGrid(resource%3DProfileBoardsResource(username%3D'.$this->userName.'))%3EGridItems(resource%3DProfileBoardsResource(username%3D'.$this->userName.'))%3EBoardCreateRep(submodule%3D%5Bobject+Object%5D%2C+ga_category%3Dboard_create)%23Modal(module%3DBoardCreate())';
			
			$hdrsArr = $this->headers('http://www.pinterest.com/resource/BoardResource/create/', 'http://www.pinterest.com', 'POST', true);
			$hdrsArr['X-NEW-APP'] = '1';
			$hdrsArr['X-APP-VERSION'] = $apVer;
			$hdrsArr['X-CSRFToken'] = $tk;
			$advSet = array('headers' => $hdrsArr, 'httpversion' => '1.1', 'timeout' => 45, 'redirection' => 0, 'cookies' => $ck, 'body' => $fldsTxt, 'ssl_off' =>$this->ssl_off);
			$rep = nxs_remote_post('http://www.pinterest.com/resource/BoardResource/create/', $advSet);
			if (is_nxs_error($rep)) {
				$badOut = print_r($rep, true) . " - ERROR";
				return $badOut;
			}
			$contents = $rep['body'];
			$resp = json_decode($contents, true); //  prr($advSettings);  prr($resp);   prr($fldsTxt);  prr($contents);    
			if (is_array($resp)) {
				if (isset($resp['resource_response']) && isset($resp['resource_response']['error']) && $resp['resource_response']['error'] != '')
					return print_r($resp['resource_response']['error'], true);
				elseif (isset($resp['resource_response']) && isset($resp['resource_response']['data']) && $resp['resource_response']['data']['id'] != '') { // gor JSON
					if (isset($resp['resource_response']) && isset($resp['resource_response']['error']) && $resp['resource_response']['error'] != '')
						return print_r($resp['resource_response']['error'], true);
					else
						return array("code" => "OK", "post_id" => $resp['resource_response']['data']['id'], "post_url" => "http://www.pinterest.com/resource/pin/" . $resp['resource_response']['data']['id']);
				}
			}elseif (stripos($contents, 'blocked this') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "Pinterest ERROR: 'The Source is blocked'. Please see https://support.pinterest.com/entries/21436306-why-is-my-pin-or-site-blocked-for-spam-or-inappropriate-content/ for more info | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'image you tried to pin is too small') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "Image you tried to pin is too small | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'CSRF verification failed') !== false) {
				$retText = trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
				return "CSRF verification failed - Please contact NextScripts Support | Pinterest Message:" . $retText;
			} elseif (stripos($contents, 'Oops') !== false && stripos($contents, '<body>') !== false)
				return 'Pinterest ERROR MESSAGE : ' . trim(str_replace(array("\r\n", "\r", "\n"), " | ", strip_tags(CutFromTo($contents, '</head>', '</body>'))));
			else
				return "Somethig is Wrong - Pinterest Returned Error 502";
		}

	}

}
?>