<?php 
if(isset($_GET['url'])){
	require __DIR__.'/private/config.php';
	
	try {
		$db = new PDO("mysql:host=".DB_HOST.";dbname=".DB_NAME, DB_LOGIN, DB_PASS);
		$stmt = $db->prepare("SELECT * FROM sites WHERE url = :url");
		$stmt->bindParam(':url', $_GET['url']);
		$stmt->execute();
		if(0 == $stmt->rowCount()){
			$stmt = $db->prepare("INSERT INTO sites (url) VALUES (:url)");
			$stmt->bindParam(':url', $_GET['url']);
			if($stmt->execute()){
				echo json_encode(array('state'=>'OK', 'url'=>$_GET['url'], 'text'=>'URL is added'));
			}else{
				echo json_encode(array('state'=>'ERROR', 'url'=>$_GET['url'], 'text'=>'internal error'));
			};
		}else{
			echo json_encode(array('state'=>'OK', 'url'=>$_GET['url'], 'text'=>'URL is added'));
		}
	}
	catch(PDOException $e) {
		echo json_encode(array('state'=>'ERROR', 'url'=>$_GET['url'], 'text'=>$e->getMessage()));
	};
	
	$db = null;
}else{
	echo "Service on line!";
}
?>