<div class="plugin_bg">
	<div id="program-wrapper">
		<?php include_once(__DIR__.'/../header.php'); ?>
		<div class="program-subnavigation si-color-green">
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show&type=facebook">Direct infiltration<span class="si-color-line"></span></a>
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show_groups&type=facebook" class="active">Sleeper infiltration<span class="si-color-line"></span></a>
			<a href="/wp-admin/admin.php?page=manage_accounts&action=app_settings&type=facebook">Facebook App Settings <span class="si-color-line"></span></a>
			<div class="search-button">
				<input type="text" placeholder="Search"/>
				<input type="submit" value=""/>
			</div>
		</div>
		<div class="program-content">
			<div class="si-setup-infiltration-block">
				<div class="program-cols-2">
					<div class="l">
						<div class="select-block">
							<p class="standart-input-description">Choose account</p>
							<select id="fb_accounts" class="si-color-green">
								<?php if (count($accounts) > 0): ?>
									<?php foreach ($accounts as $account): ?>
										<option value="<?php echo $account['fb_id'] ?>"><?php echo $account['name'] ?></option>
									<?php endforeach; ?>
								<?php endif; ?>
							</select>
						</div>
						<div class="si-checkboxes-select si-color-green">
							<input class="checkall" type="checkbox"/>
							<p class="standart-input-description">Select Groups</p>
							<div class="wrapper" id="fb_user_groups">
								<?php if (count($user_groups) > 0): ?>
									<?php foreach ($user_groups['groups'] as $user_group): ?>
										<label class="list_ittem">
											<input type="checkbox" value="<?php echo $user_group['id'] ?>" name="group[]"/>
											<span class="text"><?php echo $user_group['name'] ?></span>
											<span class="lba"></span>
										</label>
									<?php endforeach; ?>
								<?php endif; ?>
							</div>
						</div>
					</div>
					<div class="r">
						<p class="standart-input-description">Choose Group Pack</p>
						<select name="fb_package" id="fb_group_package" class="si-color-green">
							<?php if (count($fb_packages) > 0): ?>
								<?php foreach ($fb_packages as $fb_package): ?>
									<option value="<?php echo $fb_package['id'] ?>">
										<?php echo $fb_package['name'].' ('.$fb_package['count_gr'].')' ?> 
									</option>
								<?php endforeach; ?>
							<?php endif; ?>
						</select>
						
						<div class="si-buttoms-block">
							<a href="/wp-admin/admin.php?page=manage_accounts&action=add_package&type=facebook" class="btn-standart si-color-green add-ico-create si-window-addboard-open">Create a new pack</a>
							<a href="#" class="btn-standart si-color-green add-ico-save l-float" id="save_groups_btn">Save Infiltration</a>
						</div>
						<!--
						<div class="submit-block si-color-green">
							<p class="standart-input-description">Infiltrate New Groups</p>
							<div>
								<input type="text" id="fb_search_group"/><input type="submit" value="Go" id="search_group_button"/>
							</div>
						</div>
						<div class="si-checkboxes-select si-color-green">
							<input class="checkall" type="checkbox"/>
							<p class="standart-input-description">Select Groups</p>
							<div class="wrapper" name="fb_other_groups[]" id="fb_other_groups">	</div>
						</div>
						-->
					</div>
					<div class="clear"></div>
				</div>
				<div class="select-block">
					<!--
					<p class="standart-input-description">Choose Group Pack</p>
					<select name="fb_package" id="fb_group_package" class="si-color-green">
						<?php if (count($fb_packages) > 0): ?>
							<?php foreach ($fb_packages as $fb_package): ?>
								<option value="<?php echo $fb_package['id'] ?>">
									<?php echo $fb_package['name'].' ('.$fb_package['count_gr'].')' ?> 
								</option>
							<?php endforeach; ?>
						<?php endif; ?>
					</select>
					-->
				</div>
				<!--
				<div class="program-cols-2">
					<div class="l r-align">
						<a href="/wp-admin/admin.php?page=manage_accounts&action=add_package&type=facebook" class="btn-standart si-color-green add-ico-create si-window-addboard-open">Create a new board</a>
					</div>
					<div class="r">
						<a href="#" class="btn-standart si-color-green add-ico-save l-float" id="save_groups_btn">Save Infiltration</a>
						<a href="#" class="btn-standart si-color-lgreen add-ico-add r-float" id="add_new_groups_btn">Infiltrate new groups</a>
						<div class="clear"></div>
					</div>
					<div class="clear"></div>
					<br />
				</div>
				-->
			</div>
		</div>
		<div class="program-steps-buttons">
			<a href="#" class="program-step-back btn-standart">step back</a>
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show&type=twitter" class="program-step-next btn-standart si-color-green">step next</a>
		</div>
	</div>
</div>
<div class="site-window-default si-window-addboard si-color-green">
	<div class="window-title">Create a new board</div>
	<div class="window-content">
		<div class="submit-block si-color-green">
			<p class="standart-input-description">Name</p>
			<div>
				<input type="text" placeholder="Enter name" id="fb_package_name"/><input type="submit" id="create_package_btn" value="Save"/>
			</div>
		</div>
	</div>
	<div class="window-close">&times;</div>
</div>

<script type="text/javascript">
	jQuery(document).ready(function($) {
	
		updatePackegList = function(list, data){
			list.empty();
			if(null != data)
				$.each(data, function(index, el){
					list.append('<option value="'+el.id+'">'+el.name+'('+el.count_gr+')'+'</option>');
				});
			list.trigger('refresh');
		}
	
		$('#create_package_btn').click(function(){
			$.post(
				"/wp-admin/admin-ajax.php?action=cp_fb_add_package",
				{
					name : $('#fb_package_name').val(),
					user_id: $('#fb_accounts :selected').val()
				},
				function(data){
					if(data.success){
						$('#fb_group_package').find('option').removeAttr('selected');
						$('#fb_group_package').prepend('<option value="'+data.id+'" selected="selected">'+data.name+'(0)</option>').trigger('refresh');
						$('#fb_package_name').val('');
						$('.site-window-default.opened').fadeOut(300).removeClass('opened');
					}
				}, 
				'json');
			return false;			
		});
	
		$('#search_group_button').click(function(){
			$.get(
				"/wp-admin/admin-ajax.php?action=cp_fb_findgroups",
				{
					term : $('#fb_search_group').val(),
					user_id : $('#fb_accounts :selected').val()
				},
				function(data){
					if(data.length){
						updateUserGroupsList($('#fb_other_groups'),data);
					}else{
						alert('No groups find. Try reauthorize account '+$('#fb_accounts :selected').text());
					}
				}, 
				'json');
			return false;
		});
		
		$('#add_new_groups_btn').click(function(){
			addGroupsToPackeg($('#fb_other_groups'), $('#fb_group_package'))
			return false;
		})

		$('#save_groups_btn').click(function(){
			addGroupsToPackeg($('#fb_user_groups'), $('#fb_group_package'))
			return false;
		})

		$('#fb_accounts').change(function(){
			var self = this;
			$.get(
				'/wp-admin/admin-ajax.php',
				{
					action: 'cp_fb_getusergroups',
					id: $(self).find('option:selected').first().val()      // We pass php values differently!
				},
				function(data){
					var list = $('#fb_user_groups');
					var pak = $('#fb_group_package');
					if(!data.fb_groups.length) alert('No groups find. Try reauthorize account '+$('#fb_accounts :selected').text());
					updateUserGroupsList(list, data.fb_groups.groups);
					updatePackegList(pak, data.packeges);
				},
				'json');
		});
	});
</script>

