var spined_text_variants = [];
var spin_rewriter_eneble = false;

function collectSpecial(form_id){
	var $ = jQuery; 
	var data = {};	
	
	$(form_id).find('input[type=checkbox]:checked').each(function(){
		if($(this).attr('name')){
			var name = $(this).attr('name').replace(/(\[)|(\])/g,'');
			var id =   $(this).val();
			var val =  $(this).siblings('span.text').first().html();
			data[name + '[' + id + ']'] = val;			
		}
	});

	return data;
}

function collectData(form_id){
	var $ = jQuery; 
	var data = {};

	$(form_id+' select:not([multiple="multiple"])').find('option:selected').each(function(){
		data[$(this).parent('select').attr('name')] = $(this).val();
	});

	$(form_id+' select[multiple="multiple"]').find('option:selected').each(function(){
		data[$(this).parent('select').attr('id')+'['+$(this).val()+']'] = $.trim($(this).text());
	});

	$(form_id+' input[type=text]').each(function(){
		data[$(this).attr('name')] = $.trim($(this).val());
	});

	$(form_id+' input[type=hidden]').each(function(){
		data[$(this).attr('name')] = $.trim($(this).val());
	});

//	$(form_id+' input[type=checkbox]').each(function(){
//		data[$(this).attr('name')] = $.trim($(this).val());
//	});

	$(form_id+' textarea').each(function(){
		data[$(this).attr('name')] = $.trim($(this).val());
	});	

	var specialData = collectSpecial(form_id);
	$.each(specialData, function(index,val){
		data[index] = val;
	});
	
	if(spined_text_variants.length){
		$.each(spined_text_variants, function(spintax_index,spintax){
			if(spintax != undefined)
				$.each(spintax, function(message_index,message){
					data['messages['+spintax_index+']['+message_index+']'] = message;
				});	
		});		
	}
	
	
	return data;
}	

function saveStep(form_id, save_url, next_step_url){
	var $ = jQuery; 
	var data = collectData(form_id);
	$.post(
		save_url,
		data,
		function(res){
			if(res.state == 'success'){
				document.location.href = next_step_url;
				document.reload;
			}
		},
		'json');
	return false;	
}

function set_saving_text(btn){
	var $ = jQuery; 
	$(btn).text('Saving');
	setTimeout(function() {$(btn).text('Saving .')}, 1000);
	setTimeout(function() {$(btn).text('Saving ..')}, 2000);
	setTimeout(function() {$(btn).text('Saving ...')}, 3000);
}

function getSpinVariants(spin_index, callback){
	var $ = jQuery;
	callback = callback||function(){};
	var text  = $('textarea[name="spintaxes['+spin_index+']"]').val();
	var media_url  = $('input[name="media['+spin_index+']"]').val();
	var self = this;
	
	$('.program-step-next').data('blocked', 1);
	
	if(text != '')
		$.ajax({
          url: '/wp-admin/admin-ajax.php',
          data: {	
				//XDEBUG_SESSION_START:'netbeans-xdebug',
				action: 'cp_spin',
				text: text,
				media_url: media_url
			},
          dataType: 'json', 
          success: function(data){
			  $('.program-step-next').data('blocked', 0);
			  if(data.response.status == 'ERROR') {
					alert(data.response.response);
					$(self).html('spin');
					return false;
				};

				$('textarea[name="spintaxes['+spin_index+']"]').val(data.response.response);
				var spin_arr = [];
				$.each(data.response.data, function(index, text){
					spin_arr[index] = text;
				});
				spined_text_variants[spin_index] = spin_arr;
				callback(data.response);
		  },
		  error: function(data){
			 $('.program-step-next').data('blocked', 0);
		  }
		});
}

jQuery(document).ready(function($){

	function newSpinBlock(text, media_url, is_spin_enable){
		text = text|| '';
		media_url = media_url|| '';
		var class_count = parseInt($('#add_message_btn').data('classcount'), 10) + 1;
		$('#add_message_btn').data('classcount', class_count);
		//return '<div class="spin-button-wrapper"><p class="standart-input-description">Message body</p><a class="program-input-spin btn-standart si-color-wave add-ico-spin" data-index="'+class_count+'">Spin</a><textarea placeholder="Enter the message body" name="spintaxes['+class_count+']">'+text+'</textarea></div><div class="spin-button-wrapper"><p class="standart-input-description">Media(photo/video)</p><input type="text" name="media['+class_count+']" value="'+media_url+'" placeholder="Enter the photo/video url here(i.e: http://www.youtube.com/watch?v=EwntTwnUWYQ)"/></div><a href="#" class="btn-standart si-color-wave add-ico-window si-window-preclass-open" data-index="'+class_count+'">preview class</a>'
		if(is_spin_enable){
			return '<div class="spin-button-wrapper"><p class="standart-input-description">Message body</p><a class="program-input-spin btn-standart si-color-wave add-ico-spin" data-index="'+class_count+'">Spin</a><textarea class="spinax_text" name="spintaxes['+class_count+']" data-index="'+class_count+'" placeholder="Enter the message body in original text and click the SPIN button"></textarea></div><div class="adds-inputs"><div class="spin-button-wrapper"><p class="standart-input-description">Media(photo/video)</p><input type="text" placeholder="Enter the photo/video url here(i.e: http://www.youtube.com/watch?v=EwntTwnUWYQ)" name="media['+class_count+']" value="'+media_url+'"/></div></div><a href="#" class="btn-standart si-color-wave add-ico-window si-window-preclass-open" data-index="'+class_count+'">preview class</a>';
		}else{
			return '<div class="spin-button-wrapper"><p class="standart-input-description">Message body</p><a class="program-input-spin btn-standart si-color-wave add-ico-spin" data-index="'+class_count+'">Spin</a><textarea class="spinax_text" name="spintaxes['+class_count+']" data-index="'+class_count+'" placeholder="Enter the message body in spintax format"></textarea></div><div class="adds-inputs"><div class="spin-button-wrapper"><p class="standart-input-description">Media(photo/video)</p><input type="text" placeholder="Enter the photo/video url here(i.e: http://www.youtube.com/watch?v=EwntTwnUWYQ)" name="media['+class_count+']" value="'+media_url+'"/></div></div><a href="#" class="btn-standart si-color-wave add-ico-window si-window-preclass-open" data-index="'+class_count+'">preview class</a>'
			}
		
	}
	
	$(':radio,select,:checkbox').styler();
	$(':checkbox').change(function(){
		if($(this).is(':checked')){
			$(this).closest('label').addClass('checked');
		}else{
			$(this).closest('label').removeClass('checked');
		}
	})
	
	$(':radio').change(function(){
		$(document).find('input[name="'+$(this).attr('name')+'"]').closest('label').removeClass('checked');
		$(this).closest('label').addClass('checked');	
	})
	$('.si-checkboxes-select .checkall').change(function(){
		var wrapper = $(this).parent().find('.wrapper');
		if($(this).is(':checked')){
			wrapper.find('label').addClass('checked');
			wrapper.find('label input[type="checkbox"]').prop('checked', true).trigger('refresh');
		}else{
			wrapper.find('label').removeClass('checked');
			wrapper.find('label input[type="checkbox"]').prop('checked', false).trigger('refresh');
		}
	})
	$('#add_message_btn').click(function(){
		var new_block = newSpinBlock('', '', spin_rewriter_eneble);
		$(this).before(new_block);
		return false;
	})
	
	$(document).on('click','.program-input-spin',function(){
		var spin_index = $(this).data('index');
		var self = this;

		$(this).html('wait');

		getSpinVariants(spin_index, function(spin_result){
				$(self).html('spin');
			});
			
		return false;	
	})
	
	
	$(document).on('click', 'a.si-window-preclass-open', function(){
		var spintax_index = $(this).data('index');
		if(undefined != spined_text_variants[spintax_index] && spined_text_variants[spintax_index].length){
			var messages_count = spined_text_variants[spintax_index].length;
			var rand_index = Math.floor(Math.random() * messages_count) + 1;

			$('span.rand_text').html(spined_text_variants[spintax_index][rand_index]);			
		}else{
			$('span.rand_text').html($('textarea[name="spintaxes['+spintax_index+']"]').val());	
		};
		
		$('.preview-message-dialog').fadeIn(300).addClass('opened');
		
		return false;	
	})

	$(document).on('click', 'a.window-close-btn', function(){
		$('.preview-message-dialog').fadeOut(300).removeClass('opened');
		$('.site-window-default').fadeOut(300).removeClass('opened');
		
		return false;	
	})
	
	$(document).on('change', 'textarea.spinax_text', function(){
		var text = $(this).val();
		var index = $(this).data('index');
		delete spined_text_variants[index];
		if(-1 < text.indexOf('{') && -1 < text.indexOf('|') && -1 < text.indexOf('}')){
			$('.spin_result_text').html('Prepearing variants...');
			$('.spintax-forming-message-dialog').fadeIn(300).addClass('opened').css({position: 'fixed', top: '200px'});
			
			getSpinVariants(index, function(spin_result){
				$('.spin_result_text').html('Number of results are generated: ' + spin_result.data.length);
				setTimeout(function(){$('.spintax-forming-message-dialog').fadeOut(300);}, 2000);
			});
		};
	})
	
	$('.si-input-desc input').focus(function(){
		$(this).parent().addClass('focused');
	}).blur(function(){
		$(this).parent().removeClass('focused');
	})
	
	$('.si-window-addboard-open').click(function(){
		ustWindowOpen($('.si-window-addboard'));
		return false;
	})
	$('.si-window-importinfl-open').click(function(){
		ustWindowOpen($('.si-window-importinfl'));
		return false;
	})
	$('.si-window-exportinfl-open').click(function(){
		ustWindowOpen($('.si-window-exportinfl'));
		return false;
	})
	$('.si-window-bitly-open').click(function(){
		ustWindowOpen($('.si-window-bitly'));
		return false;
	})	

	$('.open-add-user-dialog').click(function(){
		ustWindowOpen($('.add-user-dialog'));
		return false;
	})

	$('.edit-gp-account-btn').click(function(){
		$('#gp_id').val($(this).data('id'));
		$('#gp_login').val($(this).data('mail'));
		$('#deauthorize_btn').attr('href', '/wp-admin/admin.php?page=manage_accounts&action=delete&type=google&id='+$(this).data('id'));
		ustWindowOpen($('.add-user-dialog'));
		return false;
	})	

	$('.site-modal-layer,.site-window-default .window-close').click(function(){
		ustWindowClose();
	})
	$(this).keydown(function(eventObject){
    	if (eventObject.which == 27){
			ustWindowClose();
		}
    });
	function ustWindowOpen(winAction){
		winAction.fadeIn(300);
		winAction.addClass('opened');
		var scrollTop = window.pageYOffset || document.documentElement.scrollTop;
		if(scrollTop+30+winAction.height() > $('body').height()){
			scrollTop = $('body').height()-winAction.height()-60;
		}
		winAction.css({
			top:scrollTop+30
		})
		//modalLayer.fadeIn(300);
	}
	function ustWindowClose(){
		$('.site-window-default.opened').fadeOut(300).removeClass('opened');
	}
	$('.si-checkboxes-select .wrapper, .si-direct-infiltration-block').addClass('scroll-pane');
	$('.scroll-pane').jScrollPane({showArrows: true});
})