<?php

/*
  Plugin Name: Traffic Elxir
  Description: Traffic Elxir Plugin allows you to send messages to a specific set of groups in social networks
  Version: 1.2.5
  Author: Precious Ngwu
 */
//ini_set('display_errors', '1');
//ini_set('error_reporting', E_ALL);
// Stop direct call
if (preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) {
	die('You are not allowed to call this page directly.');
}

// OPEN ONLY IN PRODACTION!!!!!
error_reporting( E_ERROR );

require_once('apis/NextScriptsApi/postToPinterest.php');
require_once('apis/NextScriptsApi/postToGooglePlus.php');


//require_once('apis/pinterest.api.php');

require_once('apis/bitly.php');

require_once('cp_Service.php');
require_once('cp_Infiltration.php');
require_once('social_classes/cp_Base.php');
require_once('social_classes/cp_Bitly.php');
require_once('social_classes/cp_Google.php');
require_once('social_classes/cp_Settings.php');
require_once('social_classes/cp_Spinrewriter.php');

if(!class_exists('CP_History_List_Table')){
	require_once( 'helper_classes/CP_History_List_Table.php' );
};

if(!class_exists('CP_Infiltration_Table')){
	require_once( 'helper_classes/CP_Infiltration_Table.php' );
};

add_filter('cron_schedules', 'new_interval');

// add once 1 minute interval to wp schedules
function new_interval($interval) {

    $interval['minutes_1'] = array('interval' => 1*60, 'display' => 'Once minute');

    return $interval;
}


function js_redirect($url)
{
	echo '<script type="text/javascript">';
	echo "window.location.replace('".$url."');";
	echo "</script>";
}

if (!class_exists('SociaCrossposting')) {

	class SociaCrossposting {

		public $data = array();
		private $facebook;
		public $table_names;
		static $table_names_base = array(
				'tbl_infiltrat_package_fb' => 'sp_infiltrate_packeg_fb',
				'tbl_infiltrat_package_gp' => 'sp_infiltrate_packeg_gp',
				'tbl_infiltrat_group_fb' => 'sp_infiltrate_group_fb',
				'tbl_infiltrat_users_fb' => 'sp_infiltrate_users_fb',
				'tbl_infiltrat_group_gp' => 'sp_infiltrate_group_gp',
				'tbl_infiltrat_users_gp' => 'sp_infiltrate_users_gp',
				'tbl_infiltrat_users_tw' => 'sp_infiltrate_users_tw',
				'tbl_infiltrat_users_tm' => 'sp_infiltrate_users_tm',
				'tbl_infiltrat_users_pn' => 'sp_infiltrate_users_pn',
				'tbl_infiltrate_history' => 'sp_infiltrate_history',
				'tbl_group_fb' => 'sp_group_fb',
				'tbl_package_fb' => 'sp_package_fb',
				'tbl_package_user_tw' => 'sp_package_user_tw',
				'tbl_package_tw' => 'sp_package_tw',
				'tbl_group_package_gp' => 'sp_group_package_gp',
				'tbl_package_gp' => 'sp_package_gp',
				'tbl_group_gp' => 'sp_group_gp',
				'tbl_account_pinterest_board' => 'sp_account_pn_board',			
				'tbl_infiltration_messages' => 'sp_infiltrate_messages',
				'tbl_infiltration_spintaxes' => 'sp_infiltrate_spintaxes',
				'tbl_cron_tasks' => 'sp_cron_tasks',
				'tbl_account_fb' => 'sp_account_fb',
				'tbl_account_gp' => 'sp_account_gp',
				'tbl_account_tw' => 'sp_account_tw',
				'tbl_account_tumblr' => 'sp_account_tm',
				'tbl_account_pinterest' => 'sp_account_pn',
				'tbl_infiltration' => 'sp_infiltration',
			);




		function SociaCrossposting() {
			DEFINE('SociaCrossposting', true);   ## Объявляем константу инициализации нашего плагина
			global $wpdb;

			$this->facebook = null;

			$this->plugin_name = plugin_basename(__FILE__);
			$this->plugin_url = trailingslashit(WP_PLUGIN_URL . '/' . dirname(plugin_basename(__FILE__)));

			## Таблицы
			$this->tbl_infiltration = $wpdb->prefix . 'sp_infiltration';
			$this->tbl_infiltrate_history = $wpdb->prefix . 'sp_infiltrate_history';
			$this->tbl_account_fb = $wpdb->prefix . 'sp_account_fb';
			$this->tbl_account_gp = $wpdb->prefix . 'sp_account_gp';
			$this->tbl_account_tw = $wpdb->prefix . 'sp_account_tw';
			$this->tbl_account_tumblr = $wpdb->prefix . 'sp_account_tm';
			$this->tbl_account_pinterest = $wpdb->prefix . 'sp_account_pn';
			$this->tbl_infiltrat_packeg_fb = $wpdb->prefix .'sp_infiltrate_packeg_fb';
			$this->tbl_infiltrat_packeg_gp = $wpdb->prefix .'sp_infiltrate_packeg_gp';
			$this->tbl_infiltrat_group_fb = $wpdb->prefix . 'sp_infiltrate_group_fb';
			$this->tbl_infiltrat_users_fb = $wpdb->prefix . 'sp_infiltrate_users_fb';
			$this->tbl_infiltrat_group_gp = $wpdb->prefix . 'sp_infiltrate_group_gp';
			$this->tbl_infiltrat_users_gp = $wpdb->prefix . 'sp_infiltrate_users_gp';
			$this->tbl_infiltrat_users_tw = $wpdb->prefix . 'sp_infiltrate_users_tw';
			$this->tbl_infiltrat_users_tm = $wpdb->prefix . 'sp_infiltrate_users_tm';
			$this->tbl_infiltrat_users_pn = $wpdb->prefix . 'sp_infiltrate_users_pn';
			$this->tbl_package_fb = $wpdb->prefix . 'sp_package_fb';
			$this->tbl_group_fb = $wpdb->prefix . 'sp_group_fb';
			$this->tbl_package_user_tw = $wpdb->prefix . 'sp_package_user_tw';
			$this->tbl_package_tw = $wpdb->prefix . 'sp_package_tw';
			$this->tbl_package_gp = $wpdb->prefix . 'sp_package_gp';
			$this->tbl_group_package_gp = $wpdb->prefix . 'sp_group_package_gp';
			$this->tbl_group_gp = $wpdb->prefix . 'sp_group_gp';
			$this->tbl_cron_tasks = $wpdb->prefix . 'sp_cron_tasks';
			$this->tbl_infiltration_messages = $wpdb->prefix . 'sp_infiltrate_messages';
			$this->tbl_infiltration_spintaxes = $wpdb->prefix . 'sp_infiltrate_spintaxes';
			
			$this->tbl_account_pinterest_board = $wpdb->prefix . 'sp_account_pn_board';

			foreach (SociaCrossposting::$table_names_base as $t_key => $t_name) {
				$this->table_names[$t_key] = $wpdb->prefix . $t_name;
			}

			## Функция которая исполняется при активации плагина
			register_activation_hook($this->plugin_name, array(&$this, 'activate'));

			## Функция которая исполняется при деактивации плагина
			register_deactivation_hook($this->plugin_name, array(&$this, 'deactivate'));

			##  Функция которая исполняется удалении плагина
			register_uninstall_hook($this->plugin_name, array('SociaCrossposting', 'uninstall'));

			// Добавляем крон
			add_action('admin_run_sp_cron', array(&$this, 'admin_run_sp_cron'));				
			
			// Если мы в адм. интерфейсе
			if (is_admin()) {

				add_action('init',array(&$this, 'admin_download_check'));
				
				add_action('admin_enqueue_scripts', array(&$this, 'admin_load_scripts'));
				add_action('admin_enqueue_scripts', array(&$this, 'admin_load_styles'));

				// Добавляем меню для плагина
				add_action('admin_menu', array(&$this, 'admin_generate_menu'));

				//Доюавляем аякс экшены
				add_action('wp_ajax_cp_fb_getusergroups', array(&$this, 'admin_manage_accounts_get_usergroups_fb_ajax'));
				add_action('wp_ajax_cp_fb_findgroups', array(&$this, 'admin_manage_accounts_find_groups_fb_ajax'));
				add_action('wp_ajax_cp_fb_add_new_groups', array(&$this, 'admin_manage_accounts_add_new_groups_fb_ajax'));
				add_action('wp_ajax_cp_fb_add_package', array(&$this, 'admin_manage_accounts_add_package_fb_ajax'));

				add_action('wp_ajax_cp_gp_getusergroups', array(&$this, 'admin_manage_accounts_get_usergroups_gp_ajax'));
				add_action('wp_ajax_cp_gp_findgroups', array(&$this, 'admin_manage_accounts_find_groups_gp_ajax'));
				add_action('wp_ajax_cp_gp_enterpass', array(&$this, 'admin_manage_accounts_set_pass_gp_ajax'));
				add_action('wp_ajax_cp_gp_add_package', array(&$this, 'admin_manage_accounts_add_package_gp_ajax'));
				add_action('wp_ajax_cp_gp_add_groups_to_package', array(&$this, 'admin_manage_accounts_add_groups_to_package_gp_ajax'));
				
				add_action('wp_ajax_cp_infiltration_update_fb', array(&$this, 'admin_edit_infiltration_update_fb_ajax'));
				add_action('wp_ajax_cp_infiltration_update_tw', array(&$this, 'admin_edit_infiltration_update_tw_ajax'));
				add_action('wp_ajax_cp_infiltration_update_tm', array(&$this, 'admin_edit_infiltration_update_tm_ajax'));
				add_action('wp_ajax_cp_infiltration_update_gp', array(&$this, 'admin_edit_infiltration_update_gp_ajax'));
				add_action('wp_ajax_cp_infiltration_update_pn', array(&$this, 'admin_edit_infiltration_update_pn_ajax'));
				
				add_action('wp_ajax_cp_pn_add_category', array(&$this, 'admin_edit_infiltration_pn_add_category_ajax'));
				
				add_action('wp_ajax_cp_spin', array(&$this, 'admin_edit_infiltration_spin'));
			}
		}

		public function admin_download_check(){
			if(isset($_GET['action']) && $_GET['action'] == 'export_data'){
				$settings = new cp_Settings($this->table_names);
				$settings->export_data();
				die();
			}
		}


		public function admin_plugin_info() {
			include_once('forms/plugin_info.php');
		}

		/* =================== manage_accounts ===================== */

		public function admin_manage_accounts() {
			global $wpdb;
			
			$action = isset($_GET['action']) ? $_GET['action'] : null;
			$id = isset($_GET['id']) ? $_GET['id'] : null;
			$type = isset($_GET['type']) ? $_GET['type'] : 'google';

			switch ($type) {
				case 'google' : {
						$config = get_option('cp_google_app_settings');
						if(is_string($config)) $config = unserialize($config);
						$object = new cp_Google($config);
					}; break;

				case 'settings': {
					$config = $this->table_names;
					$object = new cp_Settings($config);
					}; break;	
				
				case 'spin': {
						$object = new cp_Spinrewriter();
					}; break;					
				
				default: throw new Exception('No right class. Check parametr "Type"');
					break;
			};
			
			if (method_exists($object, $action)) {
				$object->$action();
			} else {
				$object->show();
			}
		}

		public function admin_manage_accounts_get_usergroups_fb_ajax() {
			global $wpdb;
			$user_info = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_fb . "` WHERE `fb_id`= '" . strip_tags($_GET['id']) . "'", ARRAY_A);
			$groups = $this->facebook->get_usergroups($user_info);
			
			$packeges = $wpdb->get_results("SELECT package.* , count(groups.id_group) as 'count_gr'
											FROM $this->tbl_package_fb package
											LEFT JOIN $this->tbl_group_fb groups ON groups.id_package = package.id
											WHERE package.user_id= '" . strip_tags($_GET['id']) . "'
											GROUP BY package.id", ARRAY_A);

			echo json_encode(array('fb_groups' => $groups, 'packeges' => $packeges));
			die();
		}

		public function admin_manage_accounts_add_new_groups_fb_ajax() {
			global $wpdb;
			$group_count = 0;
			$packeg_info = array();
			if(isset($_POST['packeg']) && isset($_POST['group'])){
				$existing_groups_ids = $wpdb->get_col(
											$wpdb->prepare(
													"SELECT id_group FROM $this->tbl_group_fb WHERE id_package = %d ",
													(int)$_POST['packeg']	
													) 
											); 				
				
				foreach ($_POST['group'] as $i => $name){
					if(!in_array($i, $existing_groups_ids))
								$wpdb->insert( 
										$this->tbl_group_fb,
										array('id_package' => (int)$_POST['packeg'], 'id_group' => $i, 'name' => $name),
										array('%d','%s','%s') 
										);
				};
				
				$packeg_info = $wpdb->get_row($wpdb->prepare("
						SELECT package.* , count(groups.id_group) as 'count_gr' 
						FROM $this->tbl_package_fb package 
						LEFT JOIN $this->tbl_group_fb groups ON groups.id_package = package.id
						WHERE package.id = %d
						GROUP BY package.id",
						$_POST['packeg']));
			};
			
			$data = array('state' => 'OK', 'packeg' => $packeg_info);
				
			echo json_encode($data);
			die();
		}
		
		public function admin_manage_accounts_add_package_fb_ajax(){
			global $wpdb;
			$result = array('success' => false, 'id' => '', 'name' => '');
			if(isset($_POST['name'])){
				$result['success'] = $wpdb->insert($this->tbl_package_fb, array('name' => strip_tags($_POST['name']), 'user_id' => strip_tags($_POST['user_id'])), array('%s', '%s'));
				$result['id'] = $wpdb->insert_id;
				$result['name'] = strip_tags($_POST['name']);
			};
			echo json_encode($result);
			die();
		}
		
		public function admin_manage_accounts_find_groups_fb_ajax() {
			$term = isset($_GET['term']) ? urlencode($_GET['term']) : '';
			$groups = $this->facebook->find_group($_GET['user_id'] ,$term);
			echo json_encode($groups);
			die();
		}	
		
		public function admin_manage_accounts_get_usergroups_gp_ajax() {
			$config = get_option('cp_google_app_settings');
			if(is_string($config)) $config = unserialize($config);
			
			$google = new cp_Google($config);
			
			$communities_pre = $google->get_communities($_GET['id']);
			$communities = array();
			foreach ($communities_pre as $communitie){
				$communities[] = array('id'=> $communitie['id_group'], 'name'=> $communitie['name']);
			};
			
			$packages = $google->get_packages($_GET['id']);
			
			
			echo json_encode(array('groups' => $communities, 'packages'=>$packages));
			die();
		}

		public function admin_manage_accounts_find_groups_gp_ajax() {
			global $wpdb;
			$user_info = $wpdb->get_row("SELECT * FROM `" . $this->tbl_account_gp . "` WHERE `gp_id`= '" . $_GET['id'] . "'", ARRAY_A);
			
			$config = get_option('cp_google_app_settings');
			if(is_string($config)) $config = unserialize($config);
			
			var_dump($user_info);
			
			$google = new cp_Google($config);
			$google->google_connection->setAccessToken($user_info['access_token']);
			$service = new Google_Oauth2Service($google->google_connection);
			$gp_user_info = $service->userinfo->get();

//			$pips = new Google_PlusService($google->google_connection);
//			$gp_user_info =$pips->people->listPeople('me', array());
			
			
			
			// Выведем инфо
			echo var_dump($gp_user_info);
			
			//echo json_encode($data_autocomplite);
			die();
		}
		
		public function admin_manage_accounts_set_pass_gp_ajax() {
			$config = get_option('cp_google_app_settings');
			if(is_string($config)) $config = unserialize($config);
			
			$google = new cp_Google($config);

			if($google->enter_pass($_POST['id'], $_POST['pass'])){
				echo json_encode(array('ok'=> 1));
			}else{
				echo json_encode(array('ok'=> 0));
			};
			
			die();
		}		
		
		public function admin_manage_accounts_add_package_gp_ajax(){
			global $wpdb;
			$result = array('success' => false, 'id' => '', 'name' => '');
			if(isset($_POST['name'])){
				$result['success'] = $wpdb->insert($this->tbl_package_gp, array('name' => strip_tags($_POST['name']), 'user_id' => strip_tags($_POST['user_id'])), array('%s', '%s'));
				$result['id'] = $wpdb->insert_id;
				$result['name'] = strip_tags($_POST['name']);
			};
			echo json_encode($result);
			die();
		}
		
		public function admin_manage_accounts_add_groups_to_package_gp_ajax(){
			global $wpdb;
			$packeg_info = array();
			
			
			
			if(isset($_POST['packeg']) && isset($_POST['group'])){
				$existing_groups_ids = $wpdb->get_col(
											$wpdb->prepare(
													"SELECT group_id FROM $this->tbl_group_package_gp WHERE package_id = %d ",
													(int)$_POST['packeg']	
													) 
											); 				
				
				foreach ($_POST['group'] as $i => $name){
					if(!in_array($i, $existing_groups_ids))
						$wpdb->insert( 
								$this->tbl_group_package_gp,
								array('package_id' => (int)$_POST['packeg'], 'group_id' => $i),
								array('%d','%s') 
								);
				};
				
				$packeg_info = $wpdb->get_row($wpdb->prepare("
						SELECT package.* , count(groups.group_id) as 'count_gr' 
						FROM $this->tbl_package_gp package 
						LEFT JOIN $this->tbl_group_package_gp groups ON groups.package_id = package.id
						WHERE package.id = %d
						GROUP BY package.id",
						$_POST['packeg']));
			};
			
			$data = array('state' => 'OK', 'packeg' => $packeg_info);
				
			echo json_encode($data);
			die();			
		}
		
		
		/* =================== edit_infiltrations ===================== */

		public function admin_edit_infiltrations() {
			global $wpdb;
			
			$action = isset($_GET['action']) ? $_GET['action'] : null;
			$id = isset($_GET['id']) ? (int) $_GET['id'] : null;

			if(isset($_GET['check_cron'])){
				$service = new cp_Service();
				$service->sp_check_external_cron();
			};
			
			$object = new cp_Infiltration($this->table_names, $id, array('fasebook'=>$this->facebook));
			if (method_exists($object, $action)) {
				$object->$action();
			} else {
				$object->show_infiltrations();
			}
		}

		public function admin_edit_infiltration_update_gp_ajax() {
			$id = isset($_POST['id']) ? (int) $_POST['id'] : null;
			$object = new cp_Infiltration($this->table_names, $id);

			try {
				$object->update_gp();
				echo json_encode(array('state'=>'success', 'infiltration_id' => $object->id));
			} catch (Exception $exc) {
				//echo json_encode(array('state'=>'error'));
				echo json_encode(array('state'=>$exc->getMessage()));
			};
			die();
		}		
			
		public function admin_edit_infiltration_spin(){
			$spinRewriter = new cp_Spinrewriter();
			if(strpos($_GET['text'], '{') === false || strpos($_GET['text'], '|') === false || strpos($_GET['text'], '}') === false){
				$variants = $spinRewriter->getVariantsFromText($_GET['text']);
			}else{
				$variants = array(
					'status' => 'OK',
					'response' => str_replace(array('<', '>', '&lt;', '&rt;'), '', $_GET['text']),
					'data' => $spinRewriter->getVariantsFromPentax($_GET['text'])
				);
			};
			
			$variants['media_url'] = str_replace(array('<', '>', '&lt;', '&rt;'), '', $_GET['media_url']);	

			echo json_encode(array('response'=>$variants));
			die();
		}
		
		public function admin_run_sp_cron(){
			if(!class_exists('cp_Cron')){
				require_once( 'cp_Cron.php' );
			};
			
			$sp_cron = new cp_Cron($this->table_names);
			$sp_cron->run();
		}
		
		public function activate() {
			require_once('db_tables.php');
			ob_start();
				create_tables($this);
			ob_end_clean();

			/*  SETUP CRON TASK */
			wp_schedule_event( time(), 'minutes_1',  'admin_run_sp_cron');
			
			// TODO REMOVE DEFAULT OPTIONS FOR APPS
			
			add_option('cp_google_app_settings',
						array(
							"ClientId" => '',
							"ClientSecret" => '',
							"DeveloperKey" => '',
						)
					);
	
			add_option('cp_bit_ly', 
					array(
							'bitlyKey' => 'R_875efc192b7f4e05886ed901196dad74',
							'bitlyLogin' => 'o_2a95ndvvvg',
						)
					);

			$service = new cp_Service();
			$service->sp_check_external_cron();
		}

		public static function deactivate() {
			wp_clear_scheduled_hook('admin_run_sp_cron');
			return true;
		}

		function admin_load_scripts() {
			$screen = get_current_screen();
			if('toplevel_page_edit-infiltrations' == $screen->id || 'traffic-elixir_page_manage_accounts' == $screen->id || 'traffic-elixir_page_plugin_info' == $screen->id){
				wp_enqueue_script('jquery');
				wp_enqueue_script('socialcrosspostingJs', $this->plugin_url . 'js/admin-scripts.js', array('jquery'));
				wp_enqueue_script('jquery-ui', $this->plugin_url . 'js/jquery-ui-1.10.3.custom.min.js', array('jquery'));

				wp_enqueue_script('jquery-datetimepicker', $this->plugin_url . 'js/jquery.datetimepicker.js', array('jquery'));
				wp_enqueue_script('jquery-formstyler', $this->plugin_url . 'js/jquery.formstyler.min.js', array('jquery'));
				wp_enqueue_script('jquery-jscrollpane', $this->plugin_url . 'js/jquery.jscrollpane.min.js', array('jquery'));
				wp_enqueue_script('jquery-mousewheel', $this->plugin_url . 'js/jquery.mousewheel.js', array('jquery'));
				wp_enqueue_script('main', $this->plugin_url . 'js/program.main.script.js', array('jquery'));				
			};
		}

		function admin_load_styles() {
			$screen = get_current_screen();
			
			if('toplevel_page_edit-infiltrations' == $screen->id || 'traffic-elixir_page_manage_accounts' == $screen->id || 'traffic-elixir_page_plugin_info' == $screen->id){
				wp_enqueue_style('jquery-datetimepicker', $this->plugin_url . 'css/jquery.datetimepicker.css');
				wp_enqueue_style('jquery-formstyler', $this->plugin_url . 'css/jquery.formstyler.css');
				wp_enqueue_style('jquery-jscrollpane', $this->plugin_url . 'css/jquery.jscrollpane.css');
				wp_enqueue_style('jquery-jscrollpane', $this->plugin_url . 'css/styleAbsBackup.css');
				wp_enqueue_style('socialcrosspostingCss', $this->plugin_url . 'css/style.css');
				wp_enqueue_style('googl-fonts', 'http://fonts.googleapis.com/css?family=Source+Sans+Pro:400,600,700');
			};	
		}

		function admin_generate_menu() {
			// Добавляем основной раздел меню
			add_menu_page(
					'Traffic Elixir Module',
					'Traffic Elixir',
					'manage_options',
					'edit-infiltrations',
					array(&$this, 'admin_edit_infiltrations'),
					plugins_url( 'css/images/logo.png' , __FILE__ ) 
			);

			// Добавляем дополнительный раздел
			add_submenu_page('edit-infiltrations', 'Manage accounts', 'Manage accounts', 'manage_options', 'manage_accounts', array(&$this, 'admin_manage_accounts'));
			add_submenu_page('edit-infiltrations', 'About plugin', 'About plugin', 'manage_options', 'plugin_info', array(&$this, 'admin_plugin_info'));
		}

		static function uninstall() {
			global $wpdb;

			delete_option('cp_facebook_app_settings');
			delete_option('cp_twitter_app_settings');
			delete_option('cp_tumblr_app_settings');
			delete_option('cp_google_app_settings');
			delete_option('cp_pinterest_app_settings');	
			delete_option('cp_bit_ly');
			
			require_once('db_tables.php');
			remove_tables(SociaCrossposting::$table_names_base);
		}
	}
}

global $crossposting;
$crossposting = new SociaCrossposting();
