<div class="plugin_bg">
	<div id="program-wrapper">
		<?php include_once(__DIR__.'/../header.php'); ?>
		<div class="program-subnavigation si-color-green">
			<a class="active" href="/wp-admin/admin.php?page=manage_accounts&action=show&type=google">Direct infiltration<span class="si-color-line"></span></a>
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show_groups&type=google">Sleeper infiltration<span class="si-color-line"></span></a>
			<div class="search-button">
				<input type="text" placeholder="Search"/>
				<input type="submit" value=""/>
			</div>
		</div>
		
		<div class="program-content">
			<div class="r-align b-margin">
				<a href="#" class="btn-standart add-ico-create si-color-green open-add-user-dialog">authorize new google+ account</a>
			</div>
			<div class="si-direct-infiltration-block">
				<?php if (count($accounts) > 0): ?>
					<?php foreach ($accounts as $account): ?>
						<div class="wrapper">
							<div class="img">
								<img src="<?php echo $account['image'] ?>" alt="User Image"/>
							</div>
							<div class="txt">
								<div class="name"><?php echo $account['mail'] ?></div>
								<div>
									<a href="/wp-admin/admin.php?page=manage_accounts&action=delete&type=google&id=<?php echo $account['id'];?>" class="btn-standart add-ico-del si-color-red" style="width: 120px;"	>
										Deauthorize
									</a>
								</div>
							</div>
							<div class="clear"></div>
						</div>	
					<?php endforeach; ?>
				<?php endif; ?>	
			</div>
		</div>
	
		<div class="program-steps-buttons">
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show&type=twitter" class="program-step-back btn-standart">step back</a>
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show&type=pinterest" class="program-step-next btn-standart si-color-green">step next</a>
		</div>
	</div>
</div>

<div class="site-window-default si-window-bitly si-color-green add-user-dialog" style="display: none; top: 30px;">
	<form method="POST" action="/wp-admin/admin.php?page=manage_accounts&action=add&type=google" id="edit-account-frm">
		<div class="window-title">Authorize account</div>
		<div class="window-content">
			<div class="si-radio-select si-color-green">
				<label>
					<span class="text" style="display: inline-block; width: 80px;">Login: </span>
					<input type="text" value="" name="mail">
				</label>
				<label>
					<span class="text" style="display: inline-block; width: 80px;">Password: </span>
					<input type="password" value="" name="pass" id="gp_pass">
				</label>
			</div>
		</div>
		<div class="window-footer">
			<input class="btn-standart si-color-green" type="submit" value="Add">
		</div>
		<div class="window-close">×</div>
	</form>
</div>

<?php if($loging_error):?>
	<div class="site-window-default si-window-bitly si-color-green opened" style="display: block; top: 30px; width: 620px; margin-left: -310px;">
		<div class="window-title">Error at account addition</div>
		<div class="window-content">
			<div class="si-hint_google">
				<p><b>Error at account addition</b></p>
				<p>
					If you are sure that your username and password are specified correctly, follow the instructions below.<br><br>
					<b>Your Google+ account is locked for the new applications to connect.</b>
				</p>
				<p>
					<b>[Important Note]</b>
					You need to do this from the same account you use in the plugin/api. If you are currently logged in more then one Google account, logout from all of them, login with the correct one, and then do the following:<br><br>
				</p>
				<p>
					Temporary Unlock your Google account for new applications to connect:
					<br>
					- Login to your Google+ account from your browser and visit
					<a target="_blank" href="https://www.google.com/accounts/UnlockCaptcha" title="https://www.google.com/accounts/UnlockCaptcha">https://www.google.com/accounts/UnlockCaptcha</a>
					<br>
					- You will get a message “Allow a new application to access your account”. Click “Continue”.
					<br>
					- You will get a message that you have 10 minutes to connect your application.
					<br>
					- Try authorize google+ account again.
				</p>	
			</div>
		</div>
		<div class="window-close">×</div>
	</div>
<?endif;?>