<div class="plugin_bg">
	<div class="site-window-default si-window-bitly si-color-green">
		<form action="/wp-admin/admin.php?page=manage_accounts&action=add_bitly&type=settings" method="POST" enctype="multipart/form-data">
			<div class="window-title">Authorize Bitly Account</div>
			<div class="window-content">
				<div class="si-radio-select si-color-green">
					<label>
						<span class="text" style="display: inline-block; width: 80px;">Bitly Login: </span>
						<input name="bit_login" type="text" value="<?php echo $bitly_settings?$bitly_settings['bitlyLogin']:''?>"/>
					</label>
					<label>
						<span class="text" style="display: inline-block; width: 80px;">Bitly Key: </span>
						<input name="bit_key" type="text" value="<?php echo $bitly_settings?$bitly_settings['bitlyKey']:''?>"/>
					</label>
				</div>
			</div>
			<div class="window-footer">
				<input type="submit" class="btn-standart si-color-green" value="Save"/>
			</div>
			<div class="window-close">&times;</div>
		</form>	
	</div>	
	<div class="site-window-default si-window-importinfl si-color-green">
		<form action="/wp-admin/admin.php?page=manage_accounts&action=import_data&type=settings" method="POST" enctype="multipart/form-data">
			<div class="window-title">Import another infiltration setup</div>
			<div class="window-content">
				<div class="si-radio-select si-color-green">
					<label>
						<span class="text" style="">File to upload: </span>
						<input name="userfile" type="file" />
						<span class="lba"></span>
					</label>
				</div>
			</div>
			<div class="window-footer">
				<input type="submit" class="btn-standart si-color-green" value="Save"/>
			</div>
			<div class="window-close">&times;</div>
		</form>	
	</div>
	<div class="site-window-default si-window-exportinfl si-color-wave">
		<form action="/wp-admin/admin.php" method="GET">
			<div class="window-title">Export this infiltration setup</div>
			<div class="window-content">
				<div class="si-radio-select si-color-wave">
						<label>
							<input type="radio" name="export_groups" value="0" checked="checked"/>
							<span class="text">Export only accounts</span>
							<span class="lba"></span>
						</label>
						<label>
							<input type="radio" name="export_groups" value="1"/>
							<span class="text">Export accounts with group packs</span>
							<span class="lba"></span>
						</label>
				</div>
			</div>
			<div class="window-footer">
				<input type="hidden" name="page" value="manage_accounts">
				<input type="hidden" name="action" value="export_data">
				<input type="submit" class="btn-standart si-color-wave" value="Save"/>
			</div>
		</form>	
		<div class="window-close">&times;</div>
	</div>
	<div id="program-wrapper">
		<?php include_once(plugin_dir_path(__FILE__).'/../header.php'); ?>
		<div class="program-subnavigation si-color-wave">
			<a class="active">Setup<span class="si-color-line"></span></a>
		</div>
		<div class="program-content">
			<div class="si-setup-infiltration-block">
				<div class="program-cols-2">
					<div class="l">
						<div class="program-settings-buttons">
							<a href="#" class="btn-standart si-color-green add-ico-import si-window-importinfl-open">Import another infiltration setup</a>
							<a href="#" class="btn-standart si-color-wave add-ico-export si-window-exportinfl-open">Export this infiltration setup</a>
						</div>
					</div>
					<div class="r">
						<div class="program-settings-buttons r-align">
							<a href="https://bit.ly/oauth/authorize?client_id=<?= bitly_clientid ?>&redirect_uri=<?php echo get_site_url();?>/wp-admin/admin.php?page=manage_accounts&action=show&type=settings" class="btn-standart si-color-red">
								Deactivate licence for this site
							</a>
							<?php if($bitly_settings):?>
								<a href="/wp-admin/admin.php?page=manage_accounts&action=delete_bitly&type=settings" class="btn-standart si-color-gray">Deauthorize bit.ly account</a>
							<?php else:?>
								<a href="#" class="btn-standart si-window-bitly-open si-color-gray">Authorize bit.ly account</a>
							<?php endif;?>
						</div>
					</div>
					<div class="clear"></div>
				</div>
			</div>
		</div>
		<div class="program-steps-buttons">
			<a href="/wp-admin/admin.php?page=manage_accounts&action=show&type=spin" class="program-step-back btn-standart">step back</a>
			<a href="/wp-admin/admin.php?page=edit-infiltrations" class="program-step-next btn-standart si-color-wave">finish setup</a>
		</div>
	</div>
</div>

<script type="text/javascript">
	jQuery(document).ready(function($) {
		<?php if(strlen($message)>0) :?>
				alert('<?php echo $message?>');
		<?php endif;?>		
	});
</script>
